using System;
using static System.Console;

namespace ConsoleApp3
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] unos = Console.ReadLine().Split();
            int N = int.Parse(unos[0]);
            int Q = int.Parse(unos[1]);
            int[] d = new int[N];
            int[] p = new int[N];
            int[] ostatak = new int[N];
            int[] bezPlazme = new int[N];
            int[] k = new int[Q];
            long ukupnaKolicina = 0;
            for (int i = 0; i < N; i++)
            {
                string[] dani = Console.ReadLine().Split();
                d[i] = int.Parse(dani[0]);
                p[i] = int.Parse(dani[1]);
                ukupnaKolicina += p[i];
            }
            long[] questions = new long[Q];
            for (int i = 0; i < Q; i++)
            {
                questions[i] = long.Parse(Console.ReadLine());
            }
            ostatak[0] = 0;
            bezPlazme[0] = d[0]-1;
            for (int i = 1; i < N; i++)
            {
                int razlika = p[i - 1] - (d[i] - d[i - 1]) + ostatak[i - 1];
                if (razlika < 0)
                {
                    bezPlazme[i] = Math.Abs(razlika);
                    ostatak[i] = 0;
                }
                else
                {
                    ostatak[i] = razlika;
                    bezPlazme[i] = 0;
                }
            }
            for(int i = 0; i < Q; i++) 
            {
                long danPitanja = questions[i];
                if (danPitanja <= d[0])
                {
                    WriteLine("0");
                } else if (danPitanja > ukupnaKolicina + d[N-1])
                {
                    WriteLine(ukupnaKolicina);
                }
                else {
                    long ukupnaPauza = bezPlazme[0];
                    int j = 1;
                    for (; j < N; j++)
                    {
                        if (danPitanja >= d[j])
                        {
                            ukupnaPauza += bezPlazme[j];

                        }else
                        {
                            break;
                        }
                    }
                    long razlika = p[j - 1] - (danPitanja - d[j-1]) + ostatak[j-1];
                    if(razlika < 0)
                    {
                        ukupnaPauza += razlika;
                    }
                    WriteLine(questions[i] - Math.Abs(ukupnaPauza));
                }
            }
        }
    }
}